<?php
/**
 * Plugin Name: ElementorSheets
 * Plugin URI: http://www.creativewerkdesigns.com/
 * Description: Save all Elementor Pro Form entries to Google Spreadsheet
 * Author: Creative Werk Designs
 * Author URI: http://www.creativewerkdesigns.com/
 * Version: 2.1
 */
 
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}
define( 'ELEMENTORSHEETS_PLUGIN_SECURITY', 1 );
define( 'ELEMENTORSHEETS_PLUGIN_ID', '25171650' );
// Plugin version.
define( 'ELEMENTORSHEETS_VERSION', '2.1' );
// Plugin URL.
define( 'ELEMENTORSHEETS_URL', plugin_dir_url( __FILE__ ) );
// Plugin directory.
define( 'ELEMENTORSHEETS_DIR', plugin_dir_path( __FILE__ ) );
define( 'ELEMENTORSHEETS_PATH', untrailingslashit( plugin_dir_path( __FILE__ ) ) );
define( 'ELEMENTORSHEETS_DIRECTORY', dirname( plugin_basename( __FILE__ ) ) );
define( 'ELEMENTORSHEETS_PLUGIN_SLUG', ELEMENTORSHEETS_DIRECTORY . '/' . basename( __FILE__ ) );
if ( ! class_exists( 'ElementorSheets_Dependencies' ) )
	require_once trailingslashit(dirname(__FILE__)).'includes/class-elementorsheets-dependencies.php';
// Include the main ElementorSheets class.
if ( ! class_exists( 'ElementorSheets_Setting' ) ) {
	include_once dirname( __FILE__ ) . '/includes/class-elementorsheets-setting.php';
	require_once( ELEMENTORSHEETS_PATH . '/includes/class-elementorsheets-update-updater.php' );
	require_once( ELEMENTORSHEETS_PATH . '/includes/class-elementorsheets-update-licenser.php');
	
	ElementorSheets_License()->init();
	ElementorSheets_Updater()->init();
}
/** LICENSE functions **/
function ElementorSheets_License() {
	return ElementorSheets_Update_Licenser::instance();
}
/** UPDATE functions **/
function ElementorSheets_Updater() {
	return ElementorSheets_Update_Updater::instance();
}

//Check ElementorSheets Dependency Class and Elementor Activation
if(ElementorSheets_Dependencies::is_elementor_pro_active()) {
	//Add methods if Elementor Pro is active
	add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'elementorsheets_add_action_links');
	function elementorsheets_add_action_links( $elementorsheets_links ) {
		 $elementorsheets_mylinks = array(
		 				'<a href="' . admin_url( 'admin.php?page=elementor_sheets_settings' ) . '">'.esc_html__( 'Settings', 'elementorsheets').'</a>',
		 			);
		return array_merge( $elementorsheets_mylinks, $elementorsheets_links );
	}
}else{
	add_action('admin_notices', 'elementorsheets_admin_notice');
	if (!function_exists('elementorsheets_admin_notice')) {
		function elementorsheets_admin_notice() {
			?> 
				<div class="notice error woosheets-error">
					<div class="woosheets-message-icon" style="padding: 10px 0px 23px 0px;">
						<img src="<?php echo ELEMENTORSHEETS_URL ?>images/elementorsheetslogo-notice.png" style="float:left;">
						<p style="padding-left: 64px;padding-top: 11px;"><?php echo esc_html__('ElementorSheets plugin requires Elementor Pro plugin to be active!', 'elementorsheets'); ?></p>
					</div>
				</div>
			<?php
		}
	}
}