<?php

if( !function_exists('composerRequired7e59b00b8fddc8385312f117ab4f39c'))
	require_once( dirname(__FILE__) . '/lib/vendor/autoload.php');
use ElementorPro\Plugin;
use Elementor\Controls_Manager;
use ElementorPro\Modules\Forms\Module;
class ElementorSheets_Setting {
	/**
     * Initialization 
     *
     */
    public static function elementorsheets_initilization() {
		add_action( 'admin_menu', __CLASS__. '::elementorsheets_settings_page');			
		add_action( 'elementor/editor/after_enqueue_scripts',  __CLASS__ . '::load_elementorsheets_wp_admin_style' );	
		add_action( 'admin_enqueue_scripts',  __CLASS__ . '::load_elementorsheets_wp_admin_style' );	
		add_filter( 'plugin_row_meta', __CLASS__ . '::elementorsheets_plugin_row_meta' , 10, 2 );
		add_action( 'elementor_pro/init', __CLASS__ . '::elementorsheets_init' );
		add_action( 'elementor/ajax/register_actions',  __CLASS__ . '::elementorsheets_ajax_register_action' );
		add_action( 'elementor/editor/after_save',  __CLASS__ . '::elementorsheets_after_save_settings', 10, 2 );	
		add_action('admin_notices', __CLASS__ . '::elementorsheets_admin_notice');
   	}
	
	public static function elementorsheets_admin_notice(){
		$elementorsheets_need_update_pages = ElementorSheets_Setting::elementorsheets_check_existing_page();
		if( !empty($elementorsheets_need_update_pages) ){
         	echo '<div class="notice elementor-message is-dismissible">
				<div class="elementor-message-inner">
					<div class="elementor-message-icon">
						<img src="'.ELEMENTORSHEETS_URL.'images/elementorsheetslogo-notice.png">
					</div>
					<div class="elementor-message-content">
						<strong>Thanks for updating ElementorSheets!</strong>
						<p>Please update your exiting page settings to get new feature updates.</p>
					</div>
					<div class="elementor-message-action">
						<a class="elementor-button" href="admin.php?page=elementorsheets&tab=update-settings">
							<i class="dashicons dashicons-update" aria-hidden="true"></i>
							View Update Settings</a>
					</div>
				</div>
			</div>';
		}
	}

	public static function  elementorsheets_after_save_settings( $elementorsheets_post_id , $elementorsheets_formdata ){
		global $elementorsheets_header_list, $elementorsheets_spreadsheetid, $elementorsheets_exclude_headertype;
		
		$elementorsheets_client 			= ElementorSheets_Setting::elementorsheets_getClient();
		$elementorsheets_service 			= new Google_Service_Sheets($elementorsheets_client);
		$elementorsheets_exclude_headertype = array( 'honeypot', 'recaptcha', 'recaptcha_v3', 'html');
		$elementorsheets_data 				= json_decode( stripslashes( $_REQUEST['actions'] ), true );
		
		$elementorsheets_data = Plugin::elementor()->db->iterate_data( $elementorsheets_data, function( $elementorsheets_element ) use ( &$do_update ) {
			
			if ( 'form' == $elementorsheets_element['widgetType'] ||  'global' == $elementorsheets_element['widgetType'] ) {
				
				global $elementorsheets_header_list, $elementorsheets_spreadsheetid, $elementorsheets_exclude_headertype;
				
				$elementorsheets_client 	= ElementorSheets_Setting::elementorsheets_getClient();
				$elementorsheets_service 	= new Google_Service_Sheets($elementorsheets_client);
			
				if( isset($elementorsheets_element['settings']['submit_actions']) && in_array( 'elementorsheets' ,$elementorsheets_element['settings']['submit_actions'])){
					$elementorsheets_header_list 		= array();
					$elementorsheets_spreadsheetid 		= $elementorsheets_element['settings']['spreadsheetid'];
					$elementorsheets_sheetname 			= $elementorsheets_element['settings']['sheet_name'];
					//$elementorsheets_sheetheaders 		= $elementorsheets_element['settings']['sheet_headers'];
					$elementorsheets_sheetheaders 		= array_column( $elementorsheets_element['settings']['elementorsheets_fields_map'], 'local_id');
					
					$elementorsheets_freeze_header		= $elementorsheets_element['settings']['freeze_header'];
					$elementorsheets_lead_created_date  = '';
					if( isset($elementorsheets_element['settings']['lead_created_date']) )
						$elementorsheets_lead_created_date	= $elementorsheets_element['settings']['lead_created_date'];
						
					$elementorsheets_lead_created_page_url  = '';
					if( isset($elementorsheets_element['settings']['lead_created_page_url']) )
						$elementorsheets_lead_created_page_url	= $elementorsheets_element['settings']['lead_created_page_url'];
						
						$elementorsheets_header_list = array_column( $elementorsheets_element['settings']['elementorsheets_fields_map'], 'remote_label' );
						 
						if( $elementorsheets_lead_created_date == 'yes' ){
							$elementorsheets_header_list[] = 'Submission Date';	 
						}
						
						if( $elementorsheets_lead_created_page_url == 'yes' ){
							$elementorsheets_header_list[] = 'Page Referer Url';	 
						}
						
						if( $elementorsheets_spreadsheetid == 'new' ){
							$elementorsheets_newsheetname = trim($elementorsheets_element['settings']['new_spreadsheet_name']); 
							/*
							 *Create new spreadsheet
							 */
							$elementorsheets_requestBody = new Google_Service_Sheets_Spreadsheet(array(
								 "properties" => array(
									 "title"=> $elementorsheets_newsheetname
								  ),
							 ));
							$elementorsheets_response			= $elementorsheets_service->spreadsheets->create($elementorsheets_requestBody);
							$elementorsheets_spreadsheetid 	    = $elementorsheets_response['spreadsheetId'];
						}
						
						try{
							$elementorsheets_response1 = ElementorSheets_Setting::elementorsheets_sheet_list( $elementorsheets_spreadsheetid ); 
						}
						//catch exception
						catch(Exception $e) {
						  	echo esc_html($e->getMessage());
						}
						if( $elementorsheets_response1 ){
							foreach($elementorsheets_response1->getSheets() as $key => $value) {
								 $elementorsheets_existingsheetsnames[$value['properties']['sheetId']] = $value['properties']['title'];
							}
						}
						if( !in_array ( $elementorsheets_sheetname , $elementorsheets_existingsheetsnames) ){
							/*
							 *Create new sheet into spreadsheet
							 */
							$elementorsheets_body = new Google_Service_Sheets_BatchUpdateSpreadsheetRequest(array(
								'requests' => array(
									'addSheet' => array(
										'properties' => array(
											'title' => $elementorsheets_sheetname
										)
									)
								)
							));
							try{
								$elementorsheets_response2 = $elementorsheets_service->spreadsheets->batchUpdate($elementorsheets_spreadsheetid,$elementorsheets_body);
							}
							catch(Exception $e) {
							 	echo esc_html($e->getMessage());
							}
							/**/
						
							/*
							 *Insert Sheet Headers into sheet
							 */
							
							$elementorsheets_range = trim($elementorsheets_sheetname).'!A1';
							$elementorsheets_requestBody1 = new Google_Service_Sheets_ValueRange(array(
								'values' => array( $elementorsheets_header_list )
							)); 
							$elementorsheets_params = array( 'valueInputOption' => 'RAW' ); 
							$elementorsheets_response3 = $elementorsheets_service->spreadsheets_values->append( $elementorsheets_spreadsheetid, $elementorsheets_range, $elementorsheets_requestBody1, $elementorsheets_params );
							if( $elementorsheets_element['settings']['spreadsheetid'] == 'new' ){
								$elementorsheets_requestBody2 = new Google_Service_Sheets_BatchUpdateSpreadsheetRequest(array(
									'requests' => array(
										'deleteSheet' => array(
											'sheetId' => 0
										)
									)));
								$elementorsheets_response4 = $elementorsheets_service->spreadsheets->batchUpdate($elementorsheets_spreadsheetid, $elementorsheets_requestBody2);
							}
							/**/
						}else{
							
							$elementorsheets_range = trim($elementorsheets_sheetname).'!A1';
							$elementorsheets_requestBody1 = new Google_Service_Sheets_ValueRange(array(
								'values' => array( $elementorsheets_header_list )
							)); 
							$elementorsheets_params = array( 'valueInputOption' => 'RAW' ); 
							$elementorsheets_response3 = $elementorsheets_service->spreadsheets_values->update( $elementorsheets_spreadsheetid, $elementorsheets_range, $elementorsheets_requestBody1, $elementorsheets_params );	
							
						}	
						if( $elementorsheets_freeze_header == 'yes' ){ 
							$elementorsheets_freeze = 1;
						}else{
							$elementorsheets_freeze = 0;
						} 
						ElementorSheets_Setting::freeze_header($elementorsheets_spreadsheetid,$elementorsheets_sheetname,$elementorsheets_freeze);					
				}
			}
		});
		
		if( !empty($elementorsheets_spreadsheetid) && $elementorsheets_spreadsheetid != 'new' ){ 
			$elementorsheets_saved_data = get_post_meta( $elementorsheets_post_id, '_elementor_data' );
			
			$elementorsheets_data = json_decode($elementorsheets_saved_data[0]);
			foreach ( $elementorsheets_data as $elementorsheets_elementmain_key => $elementmain_value ) {
				foreach ( $elementmain_value->elements as $elementorsheets_element_key => $element_value ) {
					foreach ( $element_value->elements as $e_key => $e_value ) {							
							if(count($e_value->elements) > 1){
								foreach ( $e_value->elements as $e_key1 => $e_value1 ) {
									foreach ( $e_value1->elements as $e_key2 => $e_value2 ) {
										if( isset($e_value2->widgetType) && $e_value2->widgetType == 'form' ){	
											$is_elementorsheets_enable = 0;
											
											foreach ( $e_value2->settings as $e_ky2 => $e_val2 ) {
												if( $e_ky2 == 'submit_actions' && in_array( 'elementorsheets', $e_val2) ){
													$is_elementorsheets_enable = 1;	
												}
												if( $e_ky2 == 'spreadsheetid' && $is_elementorsheets_enable == 1 ){
													$elementorsheets_data[$elementorsheets_elementmain_key]->elements[$elementorsheets_element_key]->elements[$e_key]->elements[$e_key1]->elements[$e_key2]->settings->spreadsheetid = $elementorsheets_spreadsheetid;
												}
												if( $e_ky2 == 'new_spreadsheet_name' && $is_elementorsheets_enable == 1 ){
													$elementorsheets_data[$elementorsheets_elementmain_key]->elements[$elementorsheets_element_key]->elements[$e_key]->elements[$e_key1]->elements[$e_key2]->settings->new_spreadsheet_name = '';
												}
												if( $e_ky2 == 'header_name' && $is_elementorsheets_enable == 1 ){
													$elementorsheets_data[$elementorsheets_elementmain_key]->elements[$elementorsheets_element_key]->elements[$e_key]->elements[$e_key1]->elements[$e_key2]->settings->header_name = '';
												}
											}	
										}
									}
								}	
							}else{					
								if( isset($e_value->widgetType) && $e_value->widgetType == 'form' ){	
									$is_elementorsheets_enable = 0;
									foreach ( $e_value->settings as $e_ky2 => $e_val2 ) {	
										if( $e_ky2 == 'submit_actions' && in_array( 'elementorsheets', $e_val2) ){
											$is_elementorsheets_enable = 1;	
										}
										if( $e_ky2 == 'spreadsheetid' && $is_elementorsheets_enable == 1 ){
											$elementorsheets_data[$elementorsheets_elementmain_key]->elements[$elementorsheets_element_key]->elements[$e_key]->settings->spreadsheetid = $elementorsheets_spreadsheetid;
										}
										if( $e_ky2 == 'new_spreadsheet_name' && $is_elementorsheets_enable == 1 ){
											$elementorsheets_data[$elementorsheets_elementmain_key]->elements[$elementorsheets_element_key]->elements[$e_key]->settings->new_spreadsheet_name = '';
										}
										if( $e_ky2 == 'header_name' && $is_elementorsheets_enable == 1 ){
											$elementorsheets_data[$elementorsheets_elementmain_key]->elements[$elementorsheets_element_key]->elements[$e_key]->settings->header_name = '';
										}
									}
								}
							
							}
						}
					}
					if( isset($elementmain_value->widgetType) && $elementmain_value->widgetType == 'form' ){	
						$is_elementorsheets_enable = 0;
						foreach ( $elementmain_value->settings as $e_ky2 => $e_val2 ) {	
							if( $e_ky2 == 'submit_actions' && in_array( 'elementorsheets', $e_val2) ){
								$is_elementorsheets_enable = 1;	
							}
							if( $e_ky2 == 'spreadsheetid' && $is_elementorsheets_enable == 1 ){
								$elementorsheets_data[$elementorsheets_elementmain_key]->settings->spreadsheetid = $elementorsheets_spreadsheetid;
							}
							if( $e_ky2 == 'new_spreadsheet_name' && $is_elementorsheets_enable == 1 ){
								$elementorsheets_data[$elementorsheets_elementmain_key]->settings->new_spreadsheet_name = '';
							}
							if( $e_ky2 == 'header_name' && $is_elementorsheets_enable == 1 ){
								$elementorsheets_data[$elementorsheets_elementmain_key]->settings->header_name = '';
							}
						}
					}	
				}	
			$elementorsheets_json_value = wp_slash( wp_json_encode( $elementorsheets_data ) );
			update_post_meta( $elementorsheets_post_id, '_elementor_data', $elementorsheets_json_value );
			}
	}
	
	public static function elementorsheets_sheet_list( $elementorsheets_spreadsheetid = '' ){
	   
	    $elementorsheets_client 	= ElementorSheets_Setting::elementorsheets_getClient();
		$elementorsheets_service 	= new Google_Service_Sheets($elementorsheets_client);
		return $elementorsheets_service->spreadsheets->get( $elementorsheets_spreadsheetid );
	}
	
	public static function freeze_header($elementorsheets_spreadsheetname,$elementorsheets_sheetname,$elementorsheets_freeze){
	   
	    $elementorsheets_client 	= ElementorSheets_Setting::elementorsheets_getClient();
		$elementorsheets_service 	= new Google_Service_Sheets($elementorsheets_client);
		$elementorsheets_response5 	= $elementorsheets_service->spreadsheets->get($elementorsheets_spreadsheetname);
		
		$elementorsheets_existingsheetsnames = array();
		
		foreach($elementorsheets_response5->getSheets() as $key => $value) {
			 $elementorsheets_existingsheetsnames[$value['properties']['sheetId']] = $value['properties']['title'];
		}
		
		$elementorsheets_is_exist = array_search( $elementorsheets_sheetname, $elementorsheets_existingsheetsnames );
			if( $elementorsheets_is_exist ){
				 // TODO: Assign values to desired properties of `requestBody`:
				$elementorsheets_requestBody3 = new Google_Service_Sheets_BatchUpdateSpreadsheetRequest(array(
					'requests' => array(
							 "updateSheetProperties" => array(
								 "properties"=> array(
									  "sheetId"=> $elementorsheets_is_exist,
									  "gridProperties"=> array(
										 "frozenRowCount" => $elementorsheets_freeze
									)
								),
								"fields"=> "gridProperties.frozenRowCount"
							)
						)
					)
				);
				$elementorsheets_response6 = $elementorsheets_service->spreadsheets->batchUpdate($elementorsheets_spreadsheetname, $elementorsheets_requestBody3);
			}
	}
	
	public static function elementorsheets_init() {
		// Here its safe to include our action class file
		include_once dirname( __FILE__ ) . '/class-elementor-form-sheets-action.php';
		// Instantiate the action class
		$elementorsheets_action = new Elementor_Form_Sheets_Action();
		// Register the action with form widget
		\ElementorPro\Plugin::instance()->modules_manager->get_modules( 'forms' )->add_form_action( $elementorsheets_action->get_name(), $elementorsheets_action );
	}
	
	public static function load_elementorsheets_wp_admin_style() {
		if( isset($_GET["page"]) && $_GET["page"] == "elementorsheets")
    	{
			wp_register_style( 'elementorsheets_wp_admin_css', plugin_dir_url(dirname(__FILE__) ) . 'css/admin-style.css', false, '1.0.0' );
			wp_enqueue_style( 'elementorsheets_wp_admin_css' );
			wp_register_script( 'elementorsheets_wp_admin_js', plugin_dir_url( dirname(__FILE__) ) . 'js/admin-script.js', false, '1.0.0');
			wp_localize_script( 'elementorsheets_wp_admin_js', 'admin_ajax_object',
				array( 
					'ajaxurl' => admin_url( 'admin-ajax.php' )
				)
			);
			wp_enqueue_script('elementorsheets_wp_admin_js');
		}
		if(  isset($_GET["action"]) && $_GET["action"] == "elementor"){
			
			wp_register_script( 'elementorsheets_wp_admin_js', plugin_dir_url( dirname(__FILE__) ) . 'js/jquery-ui.js', false, '1.0.0');
			wp_enqueue_script( 'elementorsheets_wp_admin_js');
			
			wp_register_script( 'elementorsheets_wp_customadmin_js', plugin_dir_url( dirname(__FILE__) ) . 'js/custom-elementor.js', false, '1.0.0');
			wp_localize_script( 'elementorsheets_wp_customadmin_js', 'customadmin_ajax_object',
				array( 
					'ajaxurl' => admin_url( 'admin-ajax.php' )
				)
			);
			wp_enqueue_script('elementorsheets_wp_customadmin_js');
			wp_register_style( 'elementorsheets_wp_admin_cssui', plugin_dir_url(dirname(__FILE__) ) . 'css/jquery-ui.css', false, '1.0.0' );
			wp_enqueue_style( 'elementorsheets_wp_admin_cssui' );
			wp_register_style( 'elementorsheets_wp_admin_css', plugin_dir_url(dirname(__FILE__) ) . 'css/admin-style.css', false, '1.0.0' );
			wp_enqueue_style( 'elementorsheets_wp_admin_css' );
		}
	}
	
	/**
    * Show row meta on the plugin screen.
    *
    * @param mixed $elementorsheets_links Plugin Row Meta
    * @param mixed $elementorsheets_file  Plugin Base file
    * @return  array
    */
    public static function elementorsheets_plugin_row_meta( $elementorsheets_links, $elementorsheets_file ) {
        if ( $elementorsheets_file == 'elementorsheets/elementorsheets.php' ) {
          $elementorsheets_row_meta = array(
            'docs'    => '<a href="' . esc_url( 'http://www.xhtmlpoint.com/ElementorSheets/Documentation/index.html' ) . '" title="' . esc_attr( __( 'View Documentation', 'elementorsheets' ) ) . '" target="_blank">' . esc_html__( 'Documentation', 'elementorsheets' ) . '</a>'
          );
          return array_merge( $elementorsheets_links, $elementorsheets_row_meta );
        }
        return (array) $elementorsheets_links;
    }
	
	public static function elementorsheets_settings_page() {
		$elementorsheets_page = add_menu_page(
				__( 'ElementorSheets', 'woocommerce-settings-googlesheet' ),
				'ElementorSheets',
				'manage_options',
				'elementorsheets',
				'',
				'dashicons-admin-generic',
				90
			);
			add_submenu_page( 'ElementorSheets', 'Google Sheets API Settings', 'Google Sheets API Settings', 'manage_options', 'elementorsheets',  __CLASS__ . '::elementor_sheets_plugin_page');
	}
	
	public static function elementorsheets_check_is_elementor( $page_id = 0 ){
		return \Elementor\Plugin::$instance->db->is_built_with_elementor($page_id);
	}
	
	public static function elementorsheets_check_existing_page(){
		$elementorsheets_need_update_pages  = array();
		if(!ElementorSheets_Dependencies::is_elementor_pro_active()) {
			return;
		}
		$pages = get_pages(); 
		if( empty( $pages ) ){
			return;
		}

		foreach ( $pages as $page ) {
			if( ElementorSheets_Setting::elementorsheets_check_is_elementor($page->ID) ){
				$elementorsheets_saved_data = get_post_meta( $page->ID, '_elementor_data', true );
				$elementorsheets_data = json_decode($elementorsheets_saved_data);
				if( empty($elementorsheets_data) )
					continue;
				foreach ( $elementorsheets_data as $elementorsheets_elementmain_key => $elementmain_value ) {
					foreach ( $elementmain_value->elements as $elementorsheets_element_key => $element_value ) {
						foreach ( $element_value->elements as $e_key => $e_value ) {							
							if(count($e_value->elements) > 1){
								foreach ( $e_value->elements as $e_key1 => $e_value1 ) {
									foreach ( $e_value1->elements as $e_key2 => $e_value2 ) {
										if( isset($e_value2->widgetType) && $e_value2->widgetType == 'form' ){	
											$is_elementorsheets_enable = 0;
											foreach ( $e_value2->settings as $e_ky2 => $e_val2 ) {
												if( $e_ky2 == 'submit_actions' && in_array( 'elementorsheets', $e_val2) ){
													$is_elementorsheets_enable = 1;	
												}
												if( !array_key_exists('elementorsheets_fields_map',$e_value2->settings) && $is_elementorsheets_enable == 1 ){
													$elementorsheets_need_update_pages[$page->ID] = $page->post_title;
												}
											}	
										}
										if( isset($e_value2->widgetType) && $e_value2->widgetType == 'global' ){
											if ( ! empty( $e_value2->templateID ) ) {
																
												$global_form 		= get_post_meta( $e_value2->templateID, '_elementor_data', true );
												$global_form_meta 	= json_decode( $global_form,true);
												if ( $global_form_meta ) {
													if( !isset( $global_form_meta[0]['settings']['elementorsheets_fields_map'] ) ){
														$elementorsheets_need_update_pages[$page->ID] = $page->post_title;		
													}
												}
											}
										}
									}
								}	
							}else{					
								if( isset($e_value->widgetType) && $e_value->widgetType == 'form' ){	
									$is_elementorsheets_enable = 0;
									foreach ( $e_value->settings as $e_ky2 => $e_val2 ) {	
										if( $e_ky2 == 'submit_actions' && in_array( 'elementorsheets', $e_val2) ){
											$is_elementorsheets_enable = 1;	
										}
										if( !array_key_exists('elementorsheets_fields_map',$e_value->settings) && $is_elementorsheets_enable == 1 ){
											$elementorsheets_need_update_pages[$page->ID] = $page->post_title;
										}
									}
								}
								if( isset($e_value->widgetType) && $e_value->widgetType == 'global' ){
									if ( ! empty( $e_value->templateID ) ) {
														
										$global_form 		= get_post_meta( $e_value->templateID, '_elementor_data', true );
										$global_form_meta 	= json_decode( $global_form,true);
										if ( $global_form_meta ) {
											if( !isset( $global_form_meta[0]['settings']['elementorsheets_fields_map'] ) ){
												$elementorsheets_need_update_pages[$page->ID] = $page->post_title;		
											}
										}
									}
								}
							}
						}
					}
					if( isset($elementmain_value->widgetType) && $elementmain_value->widgetType == 'form' ){	
						$is_elementorsheets_enable = 0;
						foreach ( $elementmain_value->settings as $e_ky2 => $e_val2 ) {	
							if( $e_ky2 == 'submit_actions' && in_array( 'elementorsheets', $e_val2) ){
								$is_elementorsheets_enable = 1;	
							}
							if( !array_key_exists('elementorsheets_fields_map',$elementmain_value->settings) && $is_elementorsheets_enable == 1 ){
								$elementorsheets_need_update_pages[$page->ID] = $page->post_title;
							}
						}
					}
					if( isset($elementmain_value->widgetType) && $elementmain_value->widgetType == 'global' ){
						if ( ! empty( $elementmain_value->templateID ) ) {
											
							$global_form 		= get_post_meta( $elementmain_value->templateID, '_elementor_data', true );
							$global_form_meta 	= json_decode( $global_form,true);
							if ( $global_form_meta ) {
								if( !isset( $global_form_meta[0]['settings']['elementorsheets_fields_map'] ) ){
									$elementorsheets_need_update_pages[$page->ID] = $page->post_title;		
								}
							}
						}
					}	
				}
			}
		}
		return $elementorsheets_need_update_pages;	
	}
			
	public static function elementor_sheets_plugin_page() {
		
		
		$elementorsheets_need_update_pages = ElementorSheets_Setting::elementorsheets_check_existing_page();
		if(isset($_POST['submit'])){
			if(isset($_POST['client_token'])){
				$elementorsheets_clienttoken = $_POST['client_token'];
			}else{
				$elementorsheets_clienttoken = '';	
			}
			$elementorsheets_google_settings = array($_POST['client_id'],$_POST['client_secret'],$elementorsheets_clienttoken );
			update_option('elementorsheets_google_settings', $elementorsheets_google_settings);
		}
		if(isset($_POST['revoke'])){
			$elementorsheets_google_settings    = get_option('elementorsheets_google_settings');
			$elementorsheets_google_settings[2] = '';
			update_option( 'elementorsheets_google_settings', $elementorsheets_google_settings);
			update_option( 'elementorsheets_google_accessToken', '' );
		}
		
		?>   
    	<div class="elementorsheets-sheetsheaders">
        	<div class="elementorsheets-logo-section">
            	<img src="<?php echo ELEMENTORSHEETS_URL; ?>images/logo.png">
            		<sup>V<?php echo ELEMENTORSHEETS_VERSION; ?></sup>
                    <div class="duc-btn">
            		<a target="_blank" href="http://www.xhtmlpoint.com/ElementorSheets/Documentation/index.html"><?php echo esc_html_e( "Documentation", "elementorsheets" ); ?></a>        	
	            	</div>
                    <div class="duc-btn1">
            		<a target="_blank" href="http://www.xhtmlpoint.com/ElementorSheets/Documentation/video-tutorials.html"><?php echo esc_html_e( "Video Tutorials", "elementorsheets" ); ?></a>
                    </div>
            </div>
             <div class="tab">
              <button class="tablinks googleapi-settings" onclick="elementorsheetstab(event, 'googleapi-settings')">
              	<span class="tab-icon"></span><?php echo esc_html_e( "Google API", "elementorsheets" ); ?> <br><?php echo esc_html_e( "Settings", "elementorsheets" ); ?></button>
              <button class="tablinks em-settings" onclick="elementorsheetstab(event, 'em-settings')"><span class="tab-icon"></span><?php echo esc_html_e( "Envato Market", "elementorsheets" ); ?><br><?php echo esc_html_e( "Settings", "elementorsheets" ); ?></button>
              <button class="tablinks support" onclick="elementorsheetstab(event, 'support')"> <span class="tab-icon"></span><?php echo esc_html_e( "Support", "elementorsheets" ); ?> </button>
              <button class="tablinks update-settings" onclick="elementorsheetstab(event, 'update-settings')"> <span class="tab-icon"></span><?php echo esc_html_e( "Update Settings", "elementorsheets" ); ?> </button>
            </div>
            <div id="googleapi-settings" class="tabcontent">
              <h3><?php echo esc_html_e( "Google API Settings", "elementorsheets" ); ?></h3>
              <p><?php echo esc_html_e( "Create new google APIs with Client ID and Client Secret keys to get an access for the google drive and google sheets. Please follow the documentation, login to your Gmail Account and start with", "elementorsheets" ); ?> <a href="<?php echo esc_url('http://www.xhtmlpoint.com/ElementorSheets/Documentation/sheetsetting.html'); ?>" target="_blank"><?php echo esc_html_e('here.','elementorsheets'); ?></a></p>
       			<form method="post" action="<?php echo esc_html( admin_url( 'admin.php?page=elementorsheets' ) ); ?>">
				<?php 
                    $google_settings_value = get_option('elementorsheets_google_settings');
                ?>
                    <div id="universal-message-container woocommerce">
                      <br>
                        <div class="options">
                            <table class="form-table">
                            <tr>
                                <th> <?php echo esc_html_e( "Client Id", "elementorsheets" ); ?> </th>
                                <td class="forminp forminp-text">
                                    <input type="text" name="client_id" value="<?php if( isset($google_settings_value[0]) ){ echo $google_settings_value[0];} else {echo ''; } ?>" size="80" class = "googlesettinginput" placeholder="Enter Client Id"/>
                                </td>
                            </tr>
                            <tr>
                                <th><?php echo esc_html_e( "Client Secret", "elementorsheets" ); ?> </th>
                                <td class="forminp forminp-text">
                                    <input type="text" name="client_secret" value="<?php if( isset($google_settings_value[1]) ){ echo $google_settings_value[1];} else {echo ''; } ?>" size="80" class = "googlesettinginput" placeholder="Enter Client Secret"/>
                                 </td>
                            </tr>
                            <?php 
                                if(!empty($google_settings_value[0]) && !empty($google_settings_value[1])){
                                        $token_value = $google_settings_value[2];
                            ?>
                             <tr>
                                <th><?php echo esc_html_e( "Client Token", "elementorsheets" ); ?></th>
                            <?php  
                            if( empty($token_value) && !isset( $_GET['code'] ) ){
                                $auth_url = ElementorSheets_Setting::elementorsheets_getClient();				
                             ?>
                               <td id="authbtn">
                                    <a href="<?php echo $auth_url; ?>" target="_blank" id="authlink"><div class="elementorsheets-button elementorsheets-button-secondary">Click here to generate an Authentication Token</div></a>
                               </td>
                               <?php } 
                               		$woosheets_code = ''; 
                               		if( isset( $_GET['code'] ) && !empty( $_GET['code']) )
                               			$woosheets_code = $_GET['code'];
                               ?>
                               <td class="forminp forminp-text" id="authtext" style=" <?php if( !empty($token_value) || $woosheets_code  ){ ?> display: inline-block; <?php } ?> "><input type="text" name="client_token" value="<?php  echo $token_value?$token_value:$woosheets_code ?>" size="80" placeholder="Please enter authentication code" id="client_token" class="googlesettinginput"/></td>
                              
                              </tr>
                            <?php  }if(!empty($token_value)){ ?>
                            <tr>
                                <td></td>
                                <td><input type="submit" name="revoke" id="revoke" value = "Revoke Token" class="elementorsheets-button elementorsheets-button-secondary"/></td>
                            </tr>
                            <?php } ?>    
                            </table>
                            <a target="_blank" href="http://www.xhtmlpoint.com/ElementorSheets/Documentation/video-tutorials.html">
                            <img src="<?php echo ELEMENTORSHEETS_URL; ?>images/google-api-settings-video-tutorial.png" class="video-screenshot">
                            </a>
                        </div>
                        <?php $site_url  = $_SERVER['SERVER_NAME']; ?>
                        <p class="submit"><input type="submit" name="submit" id="submit" class="elementorsheets-button elementorsheets-button-primary" value="Save"></p>
                        <table class="copy-url-table" cellpadding="0" cellspacing="0" width="100%" border="0px">
                        	<tr>
                        		<td><?php echo esc_html__( "Authorized Domain : ", "elementorsheets" ); ?></td>
                        		<td><span id="authorized_domain"><?php echo esc_html($site_url); ?></span><span class="copy-icon elementorsheets-button elementorsheets-button-primary" id="a_domain" onclick="elementorsheets_copy('authorized_domain','a_domain');"></span></td>
                        	</tr>
                        	<tr>
                        		<td><?php echo esc_html__( "Authorised redirect URIs : ", "elementorsheets" ); ?></td>
                        		<td><span id="authorized_uri"><?php echo esc_html( admin_url( 'admin.php?page=elementorsheets' ) ); ?></span><span class="copy-icon elementorsheets-button elementorsheets-button-primary" onclick="elementorsheets_copy('authorized_uri','a_uri');" id="a_uri"></span></td>
                        	</tr>
                        </table>
                    </div>
        		</form>
            </div>            
            <div id="em-settings" class="tabcontent">
              <h3><?php echo esc_html_e( "Envato Market Settings", "elementorsheets" ); ?></h3>
              <form action="" method="post">
				<?php wp_nonce_field( 'elementorsheets-special-string', '_wpnonce' ); ?>
               	<?php $api_key = get_option( 'elementorsheets_envato_apikey' ); ?>
                <div class="envato-market-blocks">
                  <p> <?php echo esc_html__( "This settings will give you smooth update experience for ElementorSheets customers. It will also notify users for new updates of the plugin.", "elementorsheets" ); ?></p>
                    <div class="elementorsheets-supportform">              
				  <div class="col-left">
					<div class="description">
						<p><?php echo esc_html_e( "Please follow the steps below:", "elementorsheets" ); ?></p>
						<ol>
						  <li><?php echo esc_html_e( "Generate an Envato API Personal Token by", "elementorsheets" ); ?> <a href='<?php echo esc_url("https://build.envato.com/create-token/?default=t&amp;purchase:download=t&amp;purchase:list=t"); ?>' target="_blank"><?php echo esc_html__( "clicking this link", "elementorsheets" ); ?></a></li>
						  <li><?php echo esc_html_e( "Name the token eg “My WordPress site”.", "elementorsheets" ); ?></li>
						  <li><?php echo esc_html_e( "Ensure the following permissions are enabled:", "elementorsheets" ); ?>
							<ul>
								<li><?php echo esc_html_e( "View and search Envato sites", "elementorsheets" ); ?></li>
								<li><?php echo esc_html_e( "Download your purchased items", "elementorsheets" ); ?></li>
								<li><?php echo esc_html_e( "List purchases you've made", "elementorsheets" ); ?></li>
							</ul>
						  </li>
						  <li><?php echo esc_html_e( "Copy the token into the Envato API Personal Token box.", "elementorsheets" ); ?></li>
						  <li><?php echo esc_html_e( 'Click the "Save" button.', 'elementorsheets' ); ?></li>
						</ol>
				  </div>
					<div class="form-field">
						<input type="text" name="ws_envato" id="ws_envato" value="<?php echo $api_key; ?>" placeholder="Envato API Personal Token" required />
					</div>
				  </div>
				  <div class="col-right">
					
				  </div>
			  </div>
          </div>
                    <p class="submit"><img src="<?php dirname(__FILE__) ?>images/spinner.gif" id="licenceloader"><span id="licencetext">Activating...</span><input type="submit" name="submit" id="licence_submit" class="elementorsheets-button elementorsheets-button-primary" value="Save"></p>
                    <span class="elementorsheets-license-result"></span>
			</form>
            </div> 
            <div id="support" class="tabcontent">
              <h3><?php echo esc_html_e( "We're here to help.", "elementorsheets" ); ?></h3>
              <p><?php echo esc_html_e( "If you have a problem that you can't solve with our knowledge base documentation, you can send a message to our support team. They can be reached 24/7.", "elementorsheets" ); ?></p>
              <div class="custom-main support-top-section">
                  <div class="left"> 
                  <h4><?php echo esc_html_e( "Need Help?", "elementorsheets" ); ?></h4>
                    <div class="elementorsheets-supportform">  
                    <p><?php echo esc_html_e( "Visit Our Support Center 24/7 to Submit A Ticket", "elementorsheets" ); ?></p>            
                      <a href='<?php echo esc_url("http://envato.creativewerkdesigns.com/tickets/index.php/signup?plugin=elementorsheets"); ?>' target="_blank"><div class="elementorsheets-button elementorsheets-button-primary" style="text-align:center;"><?php echo esc_html_e( "Submit A Ticket", "elementorsheets" ); ?></div></a>
                  </div>
                  </div>
                  <div class="right">
                    <h4><?php echo esc_html_e( "Support Includes", "elementorsheets" ); ?></h4>
                        <ul class="check-icon">
                           <li><?php echo esc_html_e( "Responding to questions or problems regarding the plugin's features", "elementorsheets" ); ?></li>
                           <li><?php echo esc_html_e( "Fixing bugs and reported issues", "elementorsheets" ); ?></li>
                           <li><?php echo esc_html_e( "Providing updates for the most popular plugins to ensure compatibility with new software versions", "elementorsheets" ); ?> </li>
                           <li><?php echo esc_html_e( "Support for 3rd party plug-ins", "elementorsheets" ); ?> </li>
                         </ul>
                         <h4><?php echo esc_html_e( "Does NOT Include", "elementorsheets" ); ?></h4>
                         <ul class="close-icon">
                            <li><?php echo esc_html_e( "Plugin Customization", "elementorsheets" ); ?></li>
                            <li><?php echo esc_html_e( "Requests that require Custom Coding", "elementorsheets" ); ?></li>
                          </ul>    
                        <hr>
                        <a href='<?php echo esc_url("http://www.xhtmlpoint.com/Elementorsheets/Documentation/faq.html"); ?>' target="_blank" class="elementorsheets-support elementorsheets-support-secondary">FAQ</a>
                  </div>
              </div>
              <div class="textwidget support-btm-section">
              <p><?php echo esc_html_e( "Support is included 6 months for customers regarding bugs and issues related with our products. You can extend this period up to 12 months.", "elementorsheets" ); ?></p>
                        <p><strong><?php echo esc_html_e( "What's not included in item support!", "elementorsheets" ); ?></strong></p>
                        <ul>
                            <li><?php echo esc_html_e( "- Item Customization", "elementorsheets" ); ?></li>
                            <li><?php echo esc_html_e( "- Hosting, Server Environment, or Software Changes", "elementorsheets" ); ?></li>
                            <li><?php echo esc_html_e( "- Help from authors of included third party assets", "elementorsheets" ); ?></li>
                        </ul>
                    <p><?php echo esc_html_e( "Read more", "elementorsheets" ); ?> <a href='<?php echo esc_url("http://codecanyon.net/page/item_support_policy"); ?>' class="AMB-ILink" target="_blank">here</a></p>
                </div>
            </div> 
            <div id="update-settings" class="tabcontent">
              <h3><?php echo esc_html_e( "Update Settigns", "elementorsheets" ); ?></h3>
               <?php
			  	if( !empty($elementorsheets_need_update_pages) ){
			  ?>
              <p class="marginbtm"><?php echo esc_html_e( "Below, you can find all old ElementorSheets page listing. Please update with new ElementorSheets setting, follow the", "elementorsheets" ); ?><a href='<?php echo esc_url("http://www.xhtmlpoint.com/ElementorSheets/Documentation/pluginsetting.html"); ?>' class="AMB-ILink" target="_blank"> <?php echo esc_html_e( "documentation", "elementorsheets" ); ?></a><?php echo esc_html_e( " or ", "elementorsheets" ); ?><a href='<?php echo esc_url("http://www.xhtmlpoint.com/ElementorSheets/Documentation/video-tutorials.html"); ?>' class="AMB-ILink" target="_blank"> <?php echo esc_html_e( "video tutorial", "elementorsheets" ); ?></a>
              </p>
              <?php } ?>
              <div class="options">
                  <div class="form-table">
              <?php	if( !empty($elementorsheets_need_update_pages) ){  ?>
              <ol>
              <?php foreach($elementorsheets_need_update_pages as $page_id => $page_title){
						$elementor_editor_link = admin_url( 'post.php?post=' . $page_id . '&action=elementor' );
						echo '<li><a href="'.$elementor_editor_link.'" target="_blank">'.$page_title.'</a></li>';	
					}  ?>
              </ol>
              <?php }else{ ?>
					 <p style="font-size:14px;margin:0px;"><?php echo esc_html_e( "All ElementorSheets pages are up to date. No update required.", "elementorsheets" );  ?> </p>
			 <?php } ?>
             </div>
             <a target="_blank" href="http://www.xhtmlpoint.com/ElementorSheets/Documentation/video-tutorials.html#elementorsheets-plugin-settings">
            	<img src="<?php echo ELEMENTORSHEETS_URL; ?>images/elementorsheets-settings-video-tutorial.png" class="video-screenshot">
            </a>
            </div>
            </div>
         </div>
    <?php	
    }
	
	/**
	* Generate token for the user and refresh the token if it's expired.
	*
	* @return array
	*/
	public static function elementorsheets_getClient()
	{	
		$elementorsheets_google_settings 	= get_option('elementorsheets_google_settings');
		$elementorsheets_clientId     		= $elementorsheets_google_settings[0];
		$elementorsheets_clientSecert 		= $elementorsheets_google_settings[1];
		$es_client 							= new Google_Client();
		$es_client->setApplicationName('ElementorSheets');
		$es_client->setScopes(Google_Service_Sheets::SPREADSHEETS_READONLY);
		$es_client->setScopes(Google_Service_Drive::DRIVE_METADATA_READONLY);
		$es_client->addScope(Google_Service_Sheets::SPREADSHEETS);
		$es_client->setClientId($elementorsheets_clientId);
		$es_client->setClientSecret($elementorsheets_clientSecert);
		//$es_client->setRedirectUri('urn:ietf:wg:oauth:2.0:oob');
		//$es_client->setAccessType('offline');
		$es_client->setRedirectUri( esc_html( admin_url( 'admin.php?page=elementorsheets' ) ) );
		$es_client->setAccessType('offline');
		$es_client->setApprovalPrompt('force');
		// Load previously authorized credentials from a file.
		$es_auth_token = $elementorsheets_google_settings[2];
		if(empty( $es_auth_token )){
			$elementorsheets_auth_url = $es_client->createAuthUrl();
			return $elementorsheets_auth_url;
		}
		$elementor_accessToken = get_option( 'elementorsheets_google_accessToken' );
		
		if ( !empty( $elementor_accessToken ) ) {
			$es_accessToken = json_decode($elementor_accessToken, true);
		} else {
			if ( empty( $es_auth_token ) ) {
				$elementorsheets_auth_url = $es_client->createAuthUrl();
				return $elementorsheets_auth_url;
			}
			else{
				$es_authCode = trim($es_auth_token);
				// Exchange authorization code for an access token.
				$es_accessToken = $es_client->fetchAccessTokenWithAuthCode($es_authCode);
				// Store the credentials to disk.
			   	update_option('elementorsheets_google_accessToken', json_encode($es_accessToken) );
			}
		}
		 $es_client->setAccessToken( $es_accessToken );
		// Refresh the token if it's expired.
		if ($es_client->isAccessTokenExpired()) {
			// save refresh token to some variable
			$es_refreshTokenSaved = $es_client->getRefreshToken();			
			$es_client->fetchAccessTokenWithRefreshToken($es_client->getRefreshToken());
			 // pass access token to some variable
			$es_accessTokenUpdated = $es_client->getAccessToken();
			// append refresh token
			$es_accessTokenUpdated['refresh_token'] = $es_refreshTokenSaved;
			//Set the new acces token
			$es_accessToken = $es_refreshTokenSaved;
			update_option('elementorsheets_google_accessToken', json_encode( $es_accessTokenUpdated ) );
			$es_accessToken = json_decode( json_encode( $es_accessTokenUpdated ), true); 
			$es_client->setAccessToken($es_accessToken);
		}
		return $es_client;
	}	
	
	public static function elementorsheets_list_googlespreedsheet()
	{
		
		$elementorsheets_client = ElementorSheets_Setting::elementorsheets_getClient();
		$elementorsheets_service = new Google_Service_Drive($elementorsheets_client);
		/* Build choices array. */
		$es_sheetarray = array(
				'' => esc_html__( 'Select Google Spreeadsheet', 'elementorsheets' ),
		);
		$es_optParams = array(
		  'fields' => 'nextPageToken, files(id, name, mimeType)',
		  'q' => "mimeType='application/vnd.google-apps.spreadsheet' and trashed = false"
		 
		);
		$es_results = $elementorsheets_service->files->listFiles($es_optParams);
		if (count($es_results->getFiles()) == 0) {
			$es_sheetarray['new'] = esc_html__( "Create New Spreadsheet", 'elementorsheets');
		} else {
			foreach ($es_results->getFiles() as $es_file) {
				$es_sheetarray[$es_file->getId()] = esc_html__( $es_file->getName(), 'elementorsheets' );
			}				
			$es_sheetarray['new'] = esc_html__( "Create New Spreadsheet", 'elementorsheets' );
		}
		return $es_sheetarray;
	}
	
	public static function elementorsheets_ajax_register_action( $elementorsheets_data1 ){
			
		$elementorsheets_exclude_headertype = array( 'honeypot', 'recaptcha', 'recaptcha_v3', 'html');
		$elementorsheets_data1 				= json_decode( stripslashes( $_REQUEST['actions'] ), true );
		
		if( isset($elementorsheets_data1['save_builder']) ){
			$elementorsheets_google_settings = get_option('elementorsheets_google_settings');
			
			if( !empty( $elementorsheets_google_settings ) ){
					
				$elementorsheets_data1 = Plugin::elementor()->db->iterate_data( $elementorsheets_data1, function( $elementorsheets_element1 ) use ( &$do_update ) {
					if ( 'form' == $elementorsheets_element1['widgetType'] ) {
						
						global $elementorsheets_header_list1, $elementorsheets_exclude_headertype, $elementorsheets_spreadsheetid1;
						
						$elementorsheets_client = ElementorSheets_Setting::elementorsheets_getClient();
						$elementorsheets_service = new Google_Service_Sheets($elementorsheets_client);
						
						if( isset($elementorsheets_element1['settings']['submit_actions']) && in_array( 'elementorsheets' ,$elementorsheets_element1['settings']['submit_actions'])){
							
							$elementorsheets_header_list1 	= array();
							$elementorsheets_spreadsheetid1 = $elementorsheets_element1['settings']['spreadsheetid'];
							$elementorsheets_sheetname 		= $elementorsheets_element1['settings']['sheet_name'];
							$elementorsheets_sheetheaders = array_column( $elementorsheets_element1['settings']['elementorsheets_fields_map'], 'local_id');
								
								if( empty( $elementorsheets_spreadsheetid1 ) ){
									$es_error = new WP_Error( esc_html__( '- Please select spreadsheet : ElementorSheets', 'elementorsheets' ), '', '' );
											wp_send_json_error( $es_error );	
								}
								
								if( $elementorsheets_spreadsheetid1 == 'new' && !isset( $elementorsheets_element1['settings']['new_spreadsheet_name'] )){
									$es_error = new WP_Error( esc_html__( '- Please enter spreadsheet name : ElementorSheets', 'elementorsheets' ), '', '' );
											wp_send_json_error( $es_error );	
								}
								
								if( empty( $elementorsheets_sheetname ) ){
									$es_error = new WP_Error( esc_html__( '- Please enter sheet name : ElementorSheets', 'elementorsheets' ), '', '' );
											wp_send_json_error( $es_error );	
								}
								if( empty( $elementorsheets_sheetheaders ) && isset($elementorsheets_sheetheaders) && !is_array($elementorsheets_sheetheaders)){
									$es_error = new WP_Error( esc_html__( '- Please select sheet headers : ElementorSheets', 'elementorsheets' ), '', '' );
											wp_send_json_error( $es_error );	
								}
								
								$elementorsheets_header_list1 = array_column( $elementorsheets_element1['settings']['elementorsheets_fields_map'], 'remote_label' );
								
								if( $elementorsheets_spreadsheetid1 != 'new' ){
									$elementorsheets_response7 = $elementorsheets_service->spreadsheets->get($elementorsheets_spreadsheetid1);
									
									foreach($elementorsheets_response7->getSheets() as $key => $value) {
										 $elementorsheets_existingsheetsnames[$value['properties']['sheetId']] = $value['properties']['title'];
									}
								
									if( in_array ( $elementorsheets_sheetname , $elementorsheets_existingsheetsnames)){
										$elementorsheets_range 		= trim($elementorsheets_sheetname).'!A1:1';
										$elementorsheets_response8 	= $elementorsheets_service->spreadsheets_values->get($elementorsheets_spreadsheetid1, $elementorsheets_range);	
										$elementorsheets_data1 	  	= $elementorsheets_response8->getValues();
										$existingheaders = $elementorsheets_data1[0];
										$is_mismatch = 0;
										
										for( $i=0; $i<count($elementorsheets_header_list1); $i++ ){
											if( isset($existingheaders[$i]) ){
												if( strtolower($elementorsheets_header_list1[$i]) != strtolower($existingheaders[$i]) )
												{
													$is_mismatch = 1;
												}
											}else{
												$is_mismatch = 1;	
											}
										}
										if( $is_mismatch ){
											$es_error = new WP_Error( esc_html__( '- Sheet Headers are not match with spreadsheet, please choose create new spreadsheet option or change sheet name. : ElementorSheets', 'elementorsheets' ), '', '' );
											wp_send_json_error( $es_error );	
										}
									}		 
								}					
							}
						}
					});	
				}
			}
		}
}
ElementorSheets_Setting::elementorsheets_initilization();